*** a/src/backend/commands/tablecmds.c
--- b/src/backend/commands/tablecmds.c
***************
*** 145,151 **** typedef struct AlteredTableInfo
  	/* Information saved by Phases 1/2 for Phase 3: */
  	List	   *constraints;	/* List of NewConstraint */
  	List	   *newvals;		/* List of NewColumnValue */
! 	bool		new_notnull;	/* T if we added new NOT NULL constraints */
  	bool		rewrite;		/* T if a rewrite is forced */
  	Oid			newTableSpace;	/* new tablespace; 0 means no change */
  	/* Objects to rebuild after completing ALTER TYPE operations */
--- 145,151 ----
  	/* Information saved by Phases 1/2 for Phase 3: */
  	List	   *constraints;	/* List of NewConstraint */
  	List	   *newvals;		/* List of NewColumnValue */
! 	bool		new_notnull;	/* T if we added new NOT NULL or PKs */
  	bool		rewrite;		/* T if a rewrite is forced */
  	Oid			newTableSpace;	/* new tablespace; 0 means no change */
  	/* Objects to rebuild after completing ALTER TYPE operations */
***************
*** 169,174 **** typedef struct NewConstraint
--- 169,186 ----
  } NewConstraint;
  
  /*
+  * Struct used to describe add/drop operations of NOT NULL constraints
+  */
+ typedef struct NotNullConstraint
+ {
+ 	char	   *conname;
+ 	char	   *attname;
+ 	AttrNumber	attnum;
+ 	bool		is_local;
+ 	int			inhcount;
+ } NotNullConstraint;
+ 
+ /*
   * Struct describing one new column value that needs to be computed during
   * Phase 3 copy (this could be either a new column with a non-null default, or
   * a column that we're changing the type of).  Columns without such an entry
***************
*** 183,188 **** typedef struct NewColumnValue
--- 195,211 ----
  } NewColumnValue;
  
  /*
+  * Struct describing the constraint information to disinherit. Currently only
+  * CHECK and NOT NULL constraints use this struct.
+  */
+ typedef struct DisinheritConstraintInfo
+ {
+ 	ConstrType	contype;		/* constraint type */
+ 	AttrNumber	attnum;			/* if NOT NULL constraint, the attnum */
+ 	char	   *conname;		/* if CHECK constraint, the constraint name */
+ } DisinheritConstraintInfo;
+ 
+ /*
   * Error-reporting support for RemoveRelations
   */
  struct dropmsgstrings
***************
*** 244,254 **** static const struct dropmsgstrings dropmsgstringarray[] = {
  
  static void truncate_check_rel(Relation rel);
  static List *MergeAttributes(List *schema, List *supers, char relpersistence,
! 				List **supOids, List **supconstr, int *supOidCount);
  static bool MergeCheckConstraint(List *constraints, char *name, Node *expr);
  static bool change_varattnos_walker(Node *node, const AttrNumber *newattno);
! static void MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel);
! static void MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel);
  static void StoreCatalogInheritance(Oid relationId, List *supers);
  static void StoreCatalogInheritance1(Oid relationId, Oid parentOid,
  						 int16 seqNumber, Relation inhRelation);
--- 267,282 ----
  
  static void truncate_check_rel(Relation rel);
  static List *MergeAttributes(List *schema, List *supers, char relpersistence,
! 				char relkind, List **supOids, List **supconstr,
! 				List **nullconstr, int *supOidCount);
  static bool MergeCheckConstraint(List *constraints, char *name, Node *expr);
+ static void StoreNotNullConstraints(Oid relid, Oid nspid, List *constraints,
+ 						char *relname, TupleDesc tupdesc);
  static bool change_varattnos_walker(Node *node, const AttrNumber *newattno);
! static void MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel,
! 										List **child_attnums);
! static void MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel,
! 										 List *child_attnums);
  static void StoreCatalogInheritance(Oid relationId, List *supers);
  static void StoreCatalogInheritance1(Oid relationId, Oid parentOid,
  						 int16 seqNumber, Relation inhRelation);
***************
*** 301,311 **** static void ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
  				bool recurse, bool recursing, LOCKMODE lockmode);
  static void add_column_datatype_dependency(Oid relid, int32 attnum, Oid typid);
  static void add_column_collation_dependency(Oid relid, int32 attnum, Oid collid);
  static void ATPrepAddOids(List **wqueue, Relation rel, bool recurse,
  			  AlterTableCmd *cmd, LOCKMODE lockmode);
! static void ATExecDropNotNull(Relation rel, const char *colName, LOCKMODE lockmode);
! static void ATExecSetNotNull(AlteredTableInfo *tab, Relation rel,
! 				 const char *colName, LOCKMODE lockmode);
  static void ATExecColumnDefault(Relation rel, const char *colName,
  					Node *newDefault, LOCKMODE lockmode);
  static void ATPrepSetStatistics(Relation rel, const char *colName,
--- 329,354 ----
  				bool recurse, bool recursing, LOCKMODE lockmode);
  static void add_column_datatype_dependency(Oid relid, int32 attnum, Oid typid);
  static void add_column_collation_dependency(Oid relid, int32 attnum, Oid collid);
+ static void StoreNotNullConstraint(Oid relid, Oid nspid,
+ 					   NotNullConstraint *constraint);
+ static HeapTuple RelationFetchNotNullConstraint(Relation pg_constraint,
+ 							   Oid relid, AttrNumber attnum);
+ static List *GetRelationNotNullConstraints(Relation rel);
+ static void CreateOrAdjustNotNullConstraint(Relation rel, AttrNumber attnum,
+ 								char *attname, int addinhcount,
+ 								int tweak_islocal);
+ static AttrNumber get_constraint_singlecol_attno(HeapTuple tup);
+ static void CreateNotNullConstraint(Relation rel, AttrNumber attnum,
+ 						char *constr_name, int inhcount, bool islocal);
  static void ATPrepAddOids(List **wqueue, Relation rel, bool recurse,
  			  AlterTableCmd *cmd, LOCKMODE lockmode);
! static bool ATExecDropNotNull(Relation rel, const char *colName,
! 				  bool recurse, bool recursing, LOCKMODE lockmode);
! static bool ATExecSetNotNull(List **wqueue, AlteredTableInfo *tab,
! 				 Relation rel, const char *colName, bool recurse,
! 				 bool recursing, LOCKMODE lockmode);
! static void ATExecSetAttNotNull(List **wqueue, AlteredTableInfo *tab,
! 					Relation rel, const char *colName, LOCKMODE lockmode);
  static void ATExecColumnDefault(Relation rel, const char *colName,
  					Node *newDefault, LOCKMODE lockmode);
  static void ATPrepSetStatistics(Relation rel, const char *colName,
***************
*** 373,379 **** static void ATExecGenericOptions(Relation rel, List *options);
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  				   ForkNumber forkNum, char relpersistence);
  static const char *storage_name(char c);
! 
  
  /* ----------------------------------------------------------------
   *		DefineRelation
--- 416,422 ----
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  				   ForkNumber forkNum, char relpersistence);
  static const char *storage_name(char c);
! static Constraint *locate_notnull_constraint(ColumnDef *def);
  
  /* ----------------------------------------------------------------
   *		DefineRelation
***************
*** 404,409 **** DefineRelation(CreateStmt *stmt, char relkind, Oid ownerId)
--- 447,453 ----
  	TupleDesc	descriptor;
  	List	   *inheritOids;
  	List	   *old_constraints;
+ 	List	   *null_constraints;
  	bool		localHasOids;
  	int			parentOidCount;
  	List	   *rawDefaults;
***************
*** 505,512 **** DefineRelation(CreateStmt *stmt, char relkind, Oid ownerId)
  	 * inherited attributes.
  	 */
  	schema = MergeAttributes(schema, stmt->inhRelations,
! 							 stmt->relation->relpersistence,
! 							 &inheritOids, &old_constraints, &parentOidCount);
  
  	/*
  	 * Create a tuple descriptor from the relation schema.	Note that this
--- 549,557 ----
  	 * inherited attributes.
  	 */
  	schema = MergeAttributes(schema, stmt->inhRelations,
! 							 stmt->relation->relpersistence, relkind,
! 							 &inheritOids, &old_constraints, &null_constraints,
! 							 &parentOidCount);
  
  	/*
  	 * Create a tuple descriptor from the relation schema.	Note that this
***************
*** 603,608 **** DefineRelation(CreateStmt *stmt, char relkind, Oid ownerId)
--- 648,657 ----
  	/* Store inheritance information for new rel. */
  	StoreCatalogInheritance(relationId, inheritOids);
  
+ 	/* Store NOT NULL constraints */
+ 	StoreNotNullConstraints(relationId, namespaceId, null_constraints,
+ 							relname, descriptor);
+ 
  	/*
  	 * We must bump the command counter to make the newly-created relation
  	 * tuple visible for opening.
***************
*** 640,645 **** DefineRelation(CreateStmt *stmt, char relkind, Oid ownerId)
--- 689,741 ----
  }
  
  /*
+  * StoreNotNullConstraints
+  *		Subroutine for DefineRelation
+  *
+  * Store a bunch of NOT NULL constraints into pg_constraint, automatically
+  * generating names for those that don't have them.  Also, take care to resolve
+  * attnums from attnames using the passed tupledesc for those attribute whose
+  * numbers could not be resolved earlier.
+  */
+ static void
+ StoreNotNullConstraints(Oid relid, Oid nspid, List *constraints, char *relname,
+ 						TupleDesc tupdesc)
+ {
+ 	ListCell	*cell;
+ 
+ 	foreach(cell, constraints)
+ 	{
+ 		NotNullConstraint *constraint = lfirst(cell);
+ 
+ 		if (constraint->attnum == InvalidAttrNumber)
+ 		{
+ 			int		i;
+ 
+ 			/*
+ 			 * XXX how can we avoid looping over the tupdesc for each
+ 			 * constraint?  Is this worth optimizing?
+ 			 */
+ 			for (i = 0; i < tupdesc->natts; i++)
+ 			{
+ 				if (strcmp(NameStr(tupdesc->attrs[i]->attname),
+ 						   constraint->attname) == 0)
+ 				{
+ 					constraint->attnum = i + 1;
+ 					break;
+ 				}
+ 			}
+ 		}
+ 
+ 		if (constraint->conname == NULL)
+ 			constraint->conname =
+ 				ChooseConstraintName(relname, constraint->attname,
+ 									 "not_null", nspid, NIL);
+ 
+ 		StoreNotNullConstraint(relid, nspid, constraint);
+ 	}
+ }
+ 
+ /*
   * Emit the right error or warning message for a "DROP" command issued on a
   * non-existent relation
   */
***************
*** 1202,1212 **** storage_name(char c)
   *		of ColumnDef's.) It is destructively changed.
   * 'supers' is a list of names (as RangeVar nodes) of parent relations.
   * 'relpersistence' is a persistence type of the table.
   *
   * Output arguments:
   * 'supOids' receives a list of the OIDs of the parent relations.
!  * 'supconstr' receives a list of constraints belonging to the parents,
   *		updated as necessary to be valid for the child.
   * 'supOidCount' is set to the number of parents that have OID columns.
   *
   * Return value:
--- 1298,1313 ----
   *		of ColumnDef's.) It is destructively changed.
   * 'supers' is a list of names (as RangeVar nodes) of parent relations.
   * 'relpersistence' is a persistence type of the table.
+  * 'relkind' is the relkind of the table.
   *
   * Output arguments:
   * 'supOids' receives a list of the OIDs of the parent relations.
!  * 'supconstr' receives a list of CHECK constraints belonging to the parents,
   *		updated as necessary to be valid for the child.
+  * 'nullconstr' receives a list of NOT NULL constraints, both the parents'
+  *      and locally defined by the child definition. NB - only filled if
+  *      it's a RELKIND_RELATION (i.e. plain table).  Otherwise, not nulls
+  *      are only recorded in the is_not_null flag of each column
   * 'supOidCount' is set to the number of parents that have OID columns.
   *
   * Return value:
***************
*** 1252,1268 **** storage_name(char c)
   *----------
   */
  static List *
! MergeAttributes(List *schema, List *supers, char relpersistence,
! 				List **supOids, List **supconstr, int *supOidCount)
  {
  	ListCell   *entry;
  	List	   *inhSchema = NIL;
  	List	   *parentOids = NIL;
  	List	   *constraints = NIL;
  	int			parentsWithOids = 0;
  	bool		have_bogus_defaults = false;
  	int			child_attno;
  	static Node bogus_marker = {0};		/* marks conflicting defaults */
  
  	/*
  	 * Check for and reject tables with too many columns. We perform this
--- 1353,1372 ----
   *----------
   */
  static List *
! MergeAttributes(List *schema, List *supers, char relpersistence, char relkind,
! 				List **supOids, List **supconstr, List **nullconstr,
! 				int *supOidCount)
  {
  	ListCell   *entry;
  	List	   *inhSchema = NIL;
  	List	   *parentOids = NIL;
  	List	   *constraints = NIL;
+ 	List	   *notnullconstrs = NIL;
  	int			parentsWithOids = 0;
  	bool		have_bogus_defaults = false;
  	int			child_attno;
  	static Node bogus_marker = {0};		/* marks conflicting defaults */
+ 	bool		collect_notnulls = relkind == RELKIND_RELATION;
  
  	/*
  	 * Check for and reject tables with too many columns. We perform this
***************
*** 1320,1325 **** MergeAttributes(List *schema, List *supers, char relpersistence,
--- 1424,1430 ----
  					 * merge the column options into the column from the type
  					 */
  					coldef->is_not_null = restdef->is_not_null;
+ 					coldef->is_primary_key = restdef->is_primary_key;
  					coldef->raw_default = restdef->raw_default;
  					coldef->cooked_default = restdef->cooked_default;
  					coldef->constraints = restdef->constraints;
***************
*** 1351,1356 **** MergeAttributes(List *schema, List *supers, char relpersistence,
--- 1456,1463 ----
  		TupleConstr *constr;
  		AttrNumber *newattno;
  		AttrNumber	parent_attno;
+ 		List	   *parent_nns;
+ 		ListCell   *cell;
  
  		/*
  		 * A self-exclusive lock is needed here.  If two backends attempt to
***************
*** 1367,1374 **** MergeAttributes(List *schema, List *supers, char relpersistence,
  					 errmsg("inherited relation \"%s\" is not a table",
  							parent->relname)));
  		/* Permanent rels cannot inherit from temporary ones */
! 		if (relpersistence != RELPERSISTENCE_TEMP
! 			&& RelationUsesTempNamespace(relation))
  			ereport(ERROR,
  					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
  					 errmsg("cannot inherit from temporary relation \"%s\"",
--- 1474,1481 ----
  					 errmsg("inherited relation \"%s\" is not a table",
  							parent->relname)));
  		/* Permanent rels cannot inherit from temporary ones */
! 		if (relpersistence != RELPERSISTENCE_TEMP &&
! 			RelationUsesTempNamespace(relation))
  			ereport(ERROR,
  					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
  					 errmsg("cannot inherit from temporary relation \"%s\"",
***************
*** 1396,1404 **** MergeAttributes(List *schema, List *supers, char relpersistence,
  		if (relation->rd_rel->relhasoids)
  			parentsWithOids++;
  
! 		tupleDesc = RelationGetDescr(relation);
  		constr = tupleDesc->constr;
  
  		/*
  		 * newattno[] will contain the child-table attribute numbers for the
  		 * attributes of this parent table.  (They are not the same for
--- 1503,1539 ----
  		if (relation->rd_rel->relhasoids)
  			parentsWithOids++;
  
! 		/*
! 		 * We want to inherit NOT NULL constraints, but not primary keys.
! 		 * Since attnotnull flags in pg_attribute stores both, we want to keep
! 		 * the attnotnull flag only on those columns that have it from NOT NULL
! 		 * constraints.  To do this, we create a copy of the table's descriptor
! 		 * and scribble on it by resetting all the attnotnull bits to false,
! 		 * and the setting them true for columns that appear in a NOT NULL
! 		 * constraint.
! 		 *
! 		 * Note: we cannot use CreateTupleDescCopy here, because it'd lose the
! 		 * atthasdef bits, as well as constraints, both of which we need below.
! 		 */
! 		tupleDesc = CreateTupleDescCopyConstr(RelationGetDescr(relation));
  		constr = tupleDesc->constr;
  
+ 		if (collect_notnulls)
+ 		{
+ 			parent_nns = GetRelationNotNullConstraints(relation);
+ 
+ 			for (parent_attno = 1; parent_attno <= tupleDesc->natts;
+ 				 parent_attno++)
+ 				tupleDesc->attrs[parent_attno - 1]->attnotnull = false;
+ 
+ 			foreach (cell, parent_nns)
+ 			{
+ 				NotNullConstraint *constr = lfirst(cell);
+ 
+ 				tupleDesc->attrs[constr->attnum - 1]->attnotnull = true;
+ 			}
+ 		}
+ 
  		/*
  		 * newattno[] will contain the child-table attribute numbers for the
  		 * attributes of this parent table.  (They are not the same for
***************
*** 1438,1443 **** MergeAttributes(List *schema, List *supers, char relpersistence,
--- 1573,1579 ----
  				Oid			defTypeId;
  				int32		deftypmod;
  				Oid			defCollId;
+ 				NotNullConstraint *nnconstr;
  
  				/*
  				 * Yes, try to merge the two column definitions. They must
***************
*** 1480,1486 **** MergeAttributes(List *schema, List *supers, char relpersistence,
  									   storage_name(attribute->attstorage))));
  
  				def->inhcount++;
! 				/* Merge of NOT NULL constraints = OR 'em together */
  				def->is_not_null |= attribute->attnotnull;
  				/* Default and other constraints are handled below */
  				newattno[parent_attno - 1] = exist_attno;
--- 1616,1665 ----
  									   storage_name(attribute->attstorage))));
  
  				def->inhcount++;
! 
! 				/*
! 				 * Merge NOT NULL constraints: create a new NotNullConstraint
! 				 * if it wasn't NOT NULL in the previous parents; bump inhcount
! 				 * if it was.
! 				 */
! 				if (collect_notnulls)
! 				{
! 					if (def->is_not_null && attribute->attnotnull)
! 					{
! 						bool	found = false;
! 						ListCell *cell;
! 
! 						foreach (cell, notnullconstrs)
! 						{
! 							nnconstr = lfirst(cell);
! 							if (strcmp(nnconstr->attname, def->colname) == 0)
! 							{
! 								found = true;
! 								break;
! 							}
! 						}
! 
! 						nnconstr->inhcount++;
! 
! 						if (!found)
! 							elog(ERROR, "missing Constraint for NOT NULL");
! 					}
! 					else if (attribute->attnotnull)
! 					{
! 						NotNullConstraint *nnconstr;
! 
! 						nnconstr = (NotNullConstraint *)
! 							palloc(sizeof(NotNullConstraint));
! 						nnconstr->conname = NULL;	/* figure out later */
! 						nnconstr->attname = pstrdup(def->colname);
! 						nnconstr->attnum = exist_attno;
! 						nnconstr->is_local = false;
! 						nnconstr->inhcount = 1;
! 						notnullconstrs = lappend(notnullconstrs, nnconstr);
! 					}
! 				}
! 
! 				/* also OR the NOT NULL bits in the ColDef */
  				def->is_not_null |= attribute->attnotnull;
  				/* Default and other constraints are handled below */
  				newattno[parent_attno - 1] = exist_attno;
***************
*** 1504,1511 **** MergeAttributes(List *schema, List *supers, char relpersistence,
  				def->collClause = NULL;
  				def->collOid = attribute->attcollation;
  				def->constraints = NIL;
- 				inhSchema = lappend(inhSchema, def);
  				newattno[parent_attno - 1] = ++child_attno;
  			}
  
  			/*
--- 1683,1704 ----
  				def->collClause = NULL;
  				def->collOid = attribute->attcollation;
  				def->constraints = NIL;
  				newattno[parent_attno - 1] = ++child_attno;
+ 
+ 				if (def->is_not_null && collect_notnulls)
+ 				{
+ 					NotNullConstraint *nnconstr;
+ 
+ 					nnconstr = (NotNullConstraint *) palloc(sizeof(NotNullConstraint));
+ 					nnconstr->conname = NULL;	/* figure out later */
+ 					nnconstr->attname = pstrdup(def->colname);
+ 					nnconstr->attnum = child_attno;
+ 					nnconstr->is_local = false;
+ 					nnconstr->inhcount = 1;
+ 					notnullconstrs = lappend(notnullconstrs, nnconstr);
+ 				}
+ 
+ 				inhSchema = lappend(inhSchema, def);
  			}
  
  			/*
***************
*** 1589,1594 **** MergeAttributes(List *schema, List *supers, char relpersistence,
--- 1782,1822 ----
  			}
  		}
  
+ 		/*
+ 		 * We also have to adjust the NOT NULL constraints that we added to the
+ 		 * child's list, by filling in the parent's name for the constraint if
+ 		 * appropriate.
+ 		 */
+ 		if (list_length(parent_nns) > 0)
+ 		{
+ 			ListCell   *childcell;
+ 
+ 			foreach (childcell, notnullconstrs)
+ 			{
+ 				NotNullConstraint *childconstr = lfirst(childcell);
+ 				ListCell   *cell;
+ 
+ 				/* name already claimed by a previous parent */
+ 				if (childconstr->conname != NULL)
+ 					continue;
+ 
+ 				foreach (cell, parent_nns)
+ 				{
+ 					NotNullConstraint *constr = lfirst(cell);
+ 
+ 					if (strcmp(childconstr->attname, constr->attname) == 0)
+ 					{
+ 						childconstr->conname = pstrdup(constr->conname);
+ 						break;
+ 					}
+ 				}
+ 
+ 				Assert(childconstr->conname != NULL);
+ 			}
+ 
+ 			/* XXX free the parent's list memory */
+ 		}
+ 
  		pfree(newattno);
  
  		/*
***************
*** 1601,1610 **** MergeAttributes(List *schema, List *supers, char relpersistence,
  
  	/*
  	 * If we had no inherited attributes, the result schema is just the
! 	 * explicitly declared columns.  Otherwise, we need to merge the declared
! 	 * columns into the inherited schema list.
  	 */
! 	if (inhSchema != NIL)
  	{
  		foreach(entry, schema)
  		{
--- 1829,1867 ----
  
  	/*
  	 * If we had no inherited attributes, the result schema is just the
! 	 * explicitly declared columns; we only need to walk it to generate NOT
! 	 * NULL constraint nodes.  If there are inherited attributes, we need to
! 	 * merge the declared columns into the inherited schema list.
  	 */
! 	if (inhSchema == NIL)
! 	{
! 		if (collect_notnulls)
! 		{
! 			foreach(entry, schema)
! 			{
! 				ColumnDef  *newdef = lfirst(entry);
! 
! 				if (newdef->is_not_null)
! 				{
! 					NotNullConstraint	*constr;
! 					Constraint		*constraint;
! 
! 					constraint = locate_notnull_constraint(newdef);
! 
! 					constr = (NotNullConstraint *)
! 						palloc(sizeof(NotNullConstraint));
! 					constr->conname = constraint->conname ?
! 						pstrdup(constraint->conname) : NULL;
! 					constr->attname = pstrdup(newdef->colname);
! 					constr->attnum = InvalidAttrNumber;
! 					constr->is_local = true;
! 					constr->inhcount = 0;
! 					notnullconstrs = lappend(notnullconstrs, constr);
! 				}
! 			}
! 		}
! 	}
! 	else
  	{
  		foreach(entry, schema)
  		{
***************
*** 1669,1676 **** MergeAttributes(List *schema, List *supers, char relpersistence,
  
  				/* Mark the column as locally defined */
  				def->is_local = true;
! 				/* Merge of NOT NULL constraints = OR 'em together */
  				def->is_not_null |= newdef->is_not_null;
  				/* If new def has a default, override previous default */
  				if (newdef->raw_default != NULL)
  				{
--- 1926,2004 ----
  
  				/* Mark the column as locally defined */
  				def->is_local = true;
! 
! 				/*
! 				 * Handle NOT NULL constraints.  We have two cases on which
! 				 * we need to do something: (1) if parents and child define the
! 				 * column as not null, there's already a NotNullConstraint node
! 				 * and we only need to flip the is_local bit.  We keep the
! 				 * child's name for the constraint, if defined; otherwise we
! 				 * use whatever was already there.  Finally, (2) if the child
! 				 * defines the column as not null but the parents didn't, then
! 				 * create a new NotNull node.
! 				 *
! 				 * The other two possibilities are (a) the parents define the
! 				 * column as not null, but the child doesn't; we don't need to
! 				 * do anything here because the constraint node is already in
! 				 * the list, and there's no need to tweak it.  Finally, (b)
! 				 * neither parents nor child define the column as not null.
! 				 */
! 				if (collect_notnulls)
! 				{
! 					if (def->is_not_null && newdef->is_not_null)	/* case 1 */
! 					{
! 						ListCell *cell;
! 						NotNullConstraint *nnconstr;
! 						Constraint	*constraint;
! 						bool		found;
! 
! 						constraint = locate_notnull_constraint(newdef);
! 
! 						/* locate the existing node */
! 						found = false;
! 						foreach (cell, notnullconstrs)
! 						{
! 							nnconstr = lfirst(cell);
! 
! 							if (strcmp(nnconstr->attname, newdef->colname) == 0)
! 							{
! 								found = true;
! 								break;
! 							}
! 						}
! 						if (!found)
! 							elog(ERROR, "missing NotNullConstraint node");
! 
! 						if (constraint->conname != NULL)
! 						{
! 							pfree(nnconstr->conname);
! 							nnconstr->conname = pstrdup(constraint->conname);
! 						}
! 						nnconstr->is_local = true;
! 
! 						/* This node is already in the NOT NULL list */
! 					}
! 					else if (!def->is_not_null && newdef->is_not_null)
! 					{
! 						Constraint			*constraint;
! 						NotNullConstraint	*constr;
! 
! 						constraint = locate_notnull_constraint(newdef);
! 						constr = (NotNullConstraint *)
! 							palloc(sizeof(NotNullConstraint));
! 						constr->conname = constraint->conname ?
! 							pstrdup(constraint->conname) : NULL;
! 						constr->attname = pstrdup(newdef->colname);
! 						constr->attnum = exist_attno;
! 						constr->is_local = true;
! 						constr->inhcount = 0;
! 						notnullconstrs = lappend(notnullconstrs, constr);
! 					}
! 				}
! 
! 				/* ... as for the columnDef list, just OR the bits together */
  				def->is_not_null |= newdef->is_not_null;
+ 
  				/* If new def has a default, override previous default */
  				if (newdef->raw_default != NULL)
  				{
***************
*** 1681,1689 **** MergeAttributes(List *schema, List *supers, char relpersistence,
  			else
  			{
  				/*
! 				 * No, attach new column to result schema
  				 */
  				inhSchema = lappend(inhSchema, newdef);
  			}
  		}
  
--- 2009,2035 ----
  			else
  			{
  				/*
! 				 * No, attach new column to result schema and handle NOT NULL
  				 */
  				inhSchema = lappend(inhSchema, newdef);
+ 
+ 				if (newdef->is_not_null && collect_notnulls)
+ 				{
+ 					NotNullConstraint	*constr;
+ 					Constraint		*constraint;
+ 
+ 					constraint = locate_notnull_constraint(newdef);
+ 
+ 					constr = (NotNullConstraint *)
+ 						palloc(sizeof(NotNullConstraint));
+ 					constr->conname = constraint->conname ?
+ 						pstrdup(constraint->conname) : NULL;
+ 					constr->attname = pstrdup(newdef->colname);
+ 					constr->attnum = InvalidAttrNumber;
+ 					constr->is_local = true;
+ 					constr->inhcount = 0;
+ 					notnullconstrs = lappend(notnullconstrs, constr);
+ 				}
  			}
  		}
  
***************
*** 1721,1726 **** MergeAttributes(List *schema, List *supers, char relpersistence,
--- 2067,2073 ----
  
  	*supOids = parentOids;
  	*supconstr = constraints;
+ 	*nullconstr = notnullconstrs;
  	*supOidCount = parentsWithOids;
  	return schema;
  }
***************
*** 1769,1774 **** MergeCheckConstraint(List *constraints, char *name, Node *expr)
--- 2116,2150 ----
  	return false;
  }
  
+ /*
+  * Find the Constraint node related to the NOT NULL marking for a column
+  */
+ static Constraint *
+ locate_notnull_constraint(ColumnDef *def)
+ {
+ 	Constraint *constraint;
+ 	bool		found = false;
+ 	ListCell   *cell;
+ 
+ 	foreach (cell, def->constraints)
+ 	{
+ 		constraint = lfirst(cell);
+ 
+ 		if (constraint->contype == CONSTR_NOTNULL)
+ 		{
+ 			found = true;
+ 			break;
+ 		}
+ 	}
+ 	/* sanity check */
+ 	if (!found)
+ 	{
+ 		constraint = NULL;		/* keep compiler quiet */
+ 		elog(ERROR, "missing Constraint node for NOT NULL constraint");
+ 	}
+ 
+ 	return constraint;
+ }
  
  /*
   * Replace varattno values in an expression tree according to the given
***************
*** 2647,2652 **** AlterTableGetLockLevel(List *cmds)
--- 3023,3029 ----
  			case AT_SetTableSpace:		/* must rewrite heap */
  			case AT_DropNotNull:		/* may change some SQL plans */
  			case AT_SetNotNull:
+ 			case AT_SetAttNotNull:
  			case AT_GenericOptions:
  				cmd_lockmode = AccessExclusiveLock;
  				break;
***************
*** 2855,2867 **** ATPrepCmd(List **wqueue, Relation rel, AlterTableCmd *cmd,
  			break;
  		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
  			ATSimplePermissions(rel, ATT_TABLE | ATT_FOREIGN_TABLE);
! 			ATSimpleRecursion(wqueue, rel, cmd, recurse, lockmode);
  			/* No command-specific prep needed */
  			pass = AT_PASS_DROP;
  			break;
  		case AT_SetNotNull:		/* ALTER COLUMN SET NOT NULL */
  			ATSimplePermissions(rel, ATT_TABLE | ATT_FOREIGN_TABLE);
! 			ATSimpleRecursion(wqueue, rel, cmd, recurse, lockmode);
  			/* No command-specific prep needed */
  			pass = AT_PASS_ADD_CONSTR;
  			break;
--- 3232,3252 ----
  			break;
  		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
  			ATSimplePermissions(rel, ATT_TABLE | ATT_FOREIGN_TABLE);
! 			if (recurse)
! 				cmd->subtype = AT_DropNotNullRecurse;
  			/* No command-specific prep needed */
  			pass = AT_PASS_DROP;
  			break;
+ 		case AT_SetAttNotNull:	/* used by DefineIndex in PRIMARY KEY case */
+ 			ATSimplePermissions(rel, ATT_TABLE | ATT_FOREIGN_TABLE);
+ 			/* This command never recurses */
+ 			/* No command-specific prep needed */
+ 			pass = AT_PASS_ADD_CONSTR;
+ 			break;
  		case AT_SetNotNull:		/* ALTER COLUMN SET NOT NULL */
  			ATSimplePermissions(rel, ATT_TABLE | ATT_FOREIGN_TABLE);
! 			if (recurse)
! 				cmd->subtype = AT_SetNotNullRecurse;
  			/* No command-specific prep needed */
  			pass = AT_PASS_ADD_CONSTR;
  			break;
***************
*** 3107,3116 **** ATExecCmd(List **wqueue, AlteredTableInfo *tab, Relation rel,
  			ATExecColumnDefault(rel, cmd->name, cmd->def, lockmode);
  			break;
  		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
! 			ATExecDropNotNull(rel, cmd->name, lockmode);
  			break;
  		case AT_SetNotNull:		/* ALTER COLUMN SET NOT NULL */
! 			ATExecSetNotNull(tab, rel, cmd->name, lockmode);
  			break;
  		case AT_SetStatistics:	/* ALTER COLUMN SET STATISTICS */
  			ATExecSetStatistics(rel, cmd->name, cmd->def, lockmode);
--- 3492,3514 ----
  			ATExecColumnDefault(rel, cmd->name, cmd->def, lockmode);
  			break;
  		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
! 			ATExecDropNotNull(rel, cmd->name, false, false, lockmode);
! 			break;
! 		case AT_DropNotNullRecurse:		/* ALTER COLUMN DROP NOT NULL with
! 										 * recursion */
! 			ATExecDropNotNull(rel, cmd->name, true, false, lockmode);
  			break;
  		case AT_SetNotNull:		/* ALTER COLUMN SET NOT NULL */
! 			ATExecSetNotNull(wqueue, tab, rel, cmd->name, false,
! 							 false, lockmode);
! 			break;
! 		case AT_SetNotNullRecurse:		/* ALTER COLUMN SET NOT NULL with
! 										 * recursion */
! 			ATExecSetNotNull(wqueue, tab, rel, cmd->name, true,
! 							 false, lockmode);
! 			break;
! 		case AT_SetAttNotNull:
! 			ATExecSetAttNotNull(wqueue, tab, rel, cmd->name, lockmode);
  			break;
  		case AT_SetStatistics:	/* ALTER COLUMN SET STATISTICS */
  			ATExecSetStatistics(rel, cmd->name, cmd->def, lockmode);
***************
*** 3558,3566 **** ATRewriteTable(AlteredTableInfo *tab, Oid OIDNewHeap, LOCKMODE lockmode)
  	{
  		/*
  		 * If we are rebuilding the tuples OR if we added any new NOT NULL
! 		 * constraints, check all not-null constraints.  This is a bit of
! 		 * overkill but it minimizes risk of bugs, and heap_attisnull is a
! 		 * pretty cheap test anyway.
  		 */
  		for (i = 0; i < newTupDesc->natts; i++)
  		{
--- 3956,3964 ----
  	{
  		/*
  		 * If we are rebuilding the tuples OR if we added any new NOT NULL
! 		 * or primary key constraints, check all not-null constraints.  This is
! 		 * a bit of overkill but it minimizes risk of bugs, and heap_attisnull
! 		 * is a pretty cheap test anyway.
  		 */
  		for (i = 0; i < newTupDesc->natts; i++)
  		{
***************
*** 3698,3705 **** ATRewriteTable(AlteredTableInfo *tab, Oid OIDNewHeap, LOCKMODE lockmode)
  				if (heap_attisnull(tuple, attn + 1))
  					ereport(ERROR,
  							(errcode(ERRCODE_NOT_NULL_VIOLATION),
! 							 errmsg("column \"%s\" contains null values",
! 								NameStr(newTupDesc->attrs[attn]->attname))));
  			}
  
  			foreach(l, tab->constraints)
--- 4096,4104 ----
  				if (heap_attisnull(tuple, attn + 1))
  					ereport(ERROR,
  							(errcode(ERRCODE_NOT_NULL_VIOLATION),
! 							 errmsg("column \"%s\" of relation \"%s\" contains null values",
! 									NameStr(newTupDesc->attrs[attn]->attname),
! 									RelationGetRelationName(oldrel))));
  			}
  
  			foreach(l, tab->constraints)
***************
*** 4203,4208 **** ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
--- 4602,4608 ----
  	Oid			collOid;
  	Form_pg_type tform;
  	Expr	   *defval;
+ 	bool        need_final_cci;
  	List	   *children;
  	ListCell   *child;
  
